package de.jottyfan.minecraft.quickiefabric.items;

import de.jottyfan.minecraft.quickiefabric.blocks.BlockSulforpad;
import de.jottyfan.minecraft.quickiefabric.blocks.QuickieBlocks;
import net.fabricmc.fabric.api.item.v1.FabricItemSettings;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.item.BoatItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.Hand;
import net.minecraft.util.TypedActionResult;
import net.minecraft.util.hit.BlockHitResult;
import net.minecraft.util.hit.HitResult;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.RaycastContext;
import net.minecraft.world.World;

/**
 *
 * @author jotty
 *
 */
public class ItemSulphor extends Item {

	public ItemSulphor() {
		super(new FabricItemSettings());
	}

	@Override
	public TypedActionResult<ItemStack> use(World world, PlayerEntity user, Hand hand) {
		ItemStack itemStack = user.getStackInHand(hand);
		BlockHitResult hitResult = BoatItem.raycast(world, user, RaycastContext.FluidHandling.SOURCE_ONLY);
		if (((HitResult) hitResult).getType() == HitResult.Type.MISS) {
			return TypedActionResult.pass(itemStack);
		}
		if (((HitResult) hitResult).getType() == HitResult.Type.BLOCK) {
			if (!world.isClient) {
				BlockPos pos = hitResult.getBlockPos();
				if (BlockSulforpad.getAllowedBlockHolder().contains(world.getBlockState(pos).getBlock()) && world.getBlockState(pos.up()).isAir()) {
					world.setBlockState(pos.up(), QuickieBlocks.SULFORPAD.getDefaultState());
					itemStack.decrement(1);
				}
			}
			return TypedActionResult.success(itemStack, world.isClient());
		}
		return TypedActionResult.pass(itemStack);
	}
}
